"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.LocalLambda = void 0;
const http_1 = require("http");
const url = __importStar(require("url"));
const DefaultPort = 8000;
class LocalLambda {
    constructor(config) {
        var _a;
        this.handler = config.handler;
        this.port = (_a = config.port) !== null && _a !== void 0 ? _a : DefaultPort;
        this.context = config.context || {};
    }
    run() {
        const server = http_1.createServer((request, response) => {
            let data = '';
            const parsedUrl = url.parse(request.url, true);
            request.on('data', chunk => {
                data += chunk;
            });
            request.on('end', async () => {
                const req = {
                    path: parsedUrl.pathname,
                    httpMethod: request.method,
                    method: request.method,
                    headers: request.headers,
                    queryStringParameters: parsedUrl.query,
                    body: data,
                };
                const rs = await this.handler(req, this.context);
                response.statusCode = rs.statusCode;
                response.writeHead(rs.statusCode, rs.headers);
                response.end(rs.body);
            });
        });
        server.listen(this.port, () => console.info(`🚀  Server ready at http://localhost:${this.port} at '${new Date().toLocaleString()}'`));
    }
}
exports.LocalLambda = LocalLambda;
//# sourceMappingURL=local.lambda.js.map